/* GCC */
#include <bits/stdc++.h>
using namespace std;
int n;
vector<vector<long long> > cost, dp;
const long long INF = 1000000000;

void DataRead()
{
    cin>> n;
    n++;
    cost.resize(n, vector<long long>(n));
    dp.resize(n, vector<long long>(1 << n, INF));

    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < n; j++)
        {
            cin>> cost[i][j];
            if(cost[i][j] < 0)
                cost[i][j] = INF;
        }
    }

    dp[0][1] = 0;
}

bool bit(int num, int i)
{
    return (num >> i) & 1;
}

void DataProcess()
{
    long long ans = INF;
    for(int curr_mask = 3; curr_mask < (1 << n); curr_mask+= 2)
    {
        int amount = 0;

        for(int i = 1; i < n; i++)
        {
            if(!bit(curr_mask, i))
                continue;
            amount++;

            int prev_mask = curr_mask - (1 << i);
            for(int j = 0; j < n; j++)
            {
                if(!bit(prev_mask, j))
                    continue;

                dp[i][curr_mask] = min(dp[i][curr_mask], dp[j][prev_mask] + cost[i][j]);
            }
        }

        int d_mask = 0;

        while(d_mask != curr_mask)
        {
            long long curr_min = INF + 1;
            int id = 0;
            for(int i = 0; i < n; i++)
            {
                if(bit(d_mask, i) || !bit(curr_mask, i))
                    continue;

                if(dp[i][curr_mask] < curr_min)
                {
                    curr_min = dp[i][curr_mask];
                    id = i;
                }
            }

            d_mask += (1 << id);

            for(int i = 0; i < n; i++)
            {
                if(bit(d_mask, i) || !bit(curr_mask, i))
                    continue;

                dp[i][curr_mask] = min(dp[i][curr_mask], dp[id][curr_mask] + cost[i][id]);
            }
        }

        ans = min(ans, dp[0][curr_mask] / amount + 1);
    }

    cout<< ans << "\n";
}

int main()
{
    freopen("vacation.in", "r", stdin);
    freopen("vacation.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    DataRead();
    DataProcess();

    return 0;
}
