/* GCC */
#include <bits/stdc++.h>

using namespace std;

#define inf 1000000000

vector<vector<int> > cost(17, vector<int>(17)), status(17, vector<int>(1<<17, inf));

int main(){
	freopen("vacation.in", "r", stdin);
	freopen("vacation.out", "w", stdout);
    int n;
    scanf("%d", &n);
    for (int i = 0; i <= n; i++){
        for (int z = 0; z <= n; z++){
            scanf("%d", &cost[i][z]);
            if (cost[i][z] < 0) cost[i][z] = inf;
        }
    }
    status[0][1] = 0;
    int ans = inf;
    for (int s = 3; s < (1<<(n+1)); s+=2){
        int currAmount = 0, prev;
        for (int i = 1; i <= n; i++){
            if (!(1<<i&s)) continue;
            currAmount++;
            prev = s-(1<<i);
            for (int j = 0; j <= n; j++){
                if (!(1<<j&prev)) continue;
                status[i][s] = min(status[i][s], status[j][prev]+cost[i][j]);
            }
        }
        int m = 0;
        while (m != s){
            int currMin = inf+1, k = 0;
            for (int i = 0; i <= n; i++){
                if (!(1<<i&s)||(1<<i&m)) continue;
                if (status[i][s] < currMin){
                    currMin = status[i][s];
                    k = i;
                }
            }
            m += (1<<k);
            for (int i = 0; i <= n; i++){
                if (!(1<<i&s)||(1<<i&m)) continue;
                status[i][s] = min(status[i][s], status[k][s]+cost[i][k]);
            }
        }
        ans = min(ans, status[0][s]/currAmount+1);
    }
    printf("%d\n", ans);
    return 0;
}



































