#include <bits/stdc++.h>
#define x first
#define y second
#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef pair<double,double> pdd;

vector < double > X, Y;
vector < pair<double,ll> > Events;

bool cmp(pair<double, ll> p1, pair<double, ll> p2)
{
    return p1.x < p2.x;
}

int main()
{
    freopen("circle.in","r",stdin);
    freopen("circle.out","w",stdout);

    ll n, k;
    cin >> n >> k;

    if(n == 1 || k==1) { cout << "0.000" << '\n'; return 0; }

    double d1, d2;
    for(ll i = 0; i<n; i++)
    {
        cin >> d1 >> d2;
        X.pb(d1); Y.pb(d2);
    }

    Events.resize(n*n);
    double LowerR = 0.0, UpperR = 20000.0;
    for(ll o = 0; o<40; o++)
    {
        double R = (LowerR+UpperR)/2.0;
        ll mx = 0;

        for(ll i = 0; i<n; i++)
        {
            ll c = 1, k = 0;

            for(ll j = 0; j<n; j++)
                if(i!=j)
                {
                    double D = hypot(X[i]-X[j], Y[i]-Y[j]);
                    if(D > 2*R) continue;

                    double d = D/2.0, H = sqrt(R*R - d*d);
                    pdd _norm = mp((X[j]-X[i])/D, (Y[j]-Y[i])/D);

                    pdd f = mp(d*_norm.x + H*_norm.y, d*_norm.y - H*_norm.x),
                        s = mp(d*_norm.x - H*_norm.y, d*_norm.y + H*_norm.x);

                    double alpha = atan2(f.y, f.x), beta = atan2(s.y, s.x);
                    if(alpha>beta) c++;

                    Events[k] = mp(alpha, 1); k++;
                    Events[k] = mp(beta, -1); k++;
                }

            sort(Events.begin(),Events.begin()+k,cmp);
            for(ll j = 0; j<k; j++)
            {
                c += Events[j].y;
                mx = max(mx,c);
            }
        }

        if(mx>=k) UpperR = R;
        else LowerR = R;
    }

    printf("%0.3f\n",(LowerR+UpperR)/2.0);
}
