#include <bits/stdc++.h>
#define pb push_back

using namespace std;

typedef long long ll;
typedef vector < ll > vll;

const ll inf = 1000000000;

vector < vll > A, F;
ll n;

ll K(ll x)
{
    ll res = 0;
    for(ll i = 0; i<n; i++) if((x>>i)&1) res++;

    return res;
}

void CountF(ll bm)
{
    bool V[20];
    for(ll i = 0; i<n; i++) if((bm>>i)&1) V[i] = 1; else V[i] = 0;

    ll D[20];
    for(ll i = 0; i<n; i++) if(V[i]) D[i] = inf; else D[i] = -1;

    for(ll i = 0; i<n; i++)
        if(V[i])
        for(ll j = 0; j<n; j++)
            if(V[j] && i!=j && A[j+1][i+1] >= 0) D[i] = min(D[i], F[bm - (1<<i)][j] + A[j+1][i+1]);

    D[n] = inf + 1;
    while(true)
    {
        ll j = n;
        for(ll i = 0; i<n; i++) if(D[i] >= 0 && D[i]<D[j]) j = i;
        if(j==n) break;

        F[bm][j] = D[j];
        for(ll i = 0; i<n; i++) if(i!=j && D[i] > 0 && A[i+1][j+1] >= 0) D[i] = min(D[i], D[j] + A[i+1][j+1]);
        D[j] = -1;
    }
}

int main()
{
    freopen("vacation.in","r",stdin);
    freopen("vacation.out","w",stdout);
    cin >> n;

    ll c;
    A.resize(n+1);
    for(ll i = 0; i<n+1; i++)
        for(ll j = 0; j<n+1; j++)
        {
            cin >> c;
            A[i].pb(c);
        }

    ll e = (1<<n) - 1;
    F.resize(e+1,vll(n,0));

    for(ll i = 0; i<n; i++) if(A[0][i+1] >= 0) F[(1<<i)][i] = A[0][i+1];

    for(ll i = 0; i<=e; i++) if(K(i) > 1) CountF(i);

    ll bestT = inf;
    for(ll i = 0; i<=e; i++)
        for(ll j = 0; j<n; j++)
            if(A[j+1][0] >= 0 && ((i>>j)&1)) bestT = min(bestT, (F[i][j] + A[0][j+1])/K(i) + 1);

    cout << bestT << '\n';
}
