/* GCC */
#include<iostream>
#include<cstdio>

using namespace std;

const int N = 16+1, inf = 1e9;

int n;
int a[N][N];

int d[1<<N][N];
int solve(){
    for(int s = 0; s < (1<<n); ++s)
        for(int i = 0; i < n; ++i)
            d[s][i] = inf;
    for(int i = 0; i < n; ++i)
        d[1<<i][i] = a[0][i+1];
    int ans = inf;
    for(int s = 1; s < (1<<n); ++s){
        int cnt = __builtin_popcount(s);
        for(int i = 0; i < n; ++i){
            if(!(s&(1<<i)))
                continue;
            for(int j = 0; j < n; ++j){
                if(i == j || !(s&(1<<j)))
                    continue;
                d[s][j] = min(d[s][j], d[s^(1<<j)][i] + a[i+1][j+1]);
            }
        }
        int m = 0;
        while(m != s){
            int mn = inf+1, i = -1;
            for(int j = 0; j < n; ++j){
                if(!(s&(1<<j)) || (m&(1<<j)))
                    continue;
                if(d[s][j] < mn){
                    mn = d[s][j];
                    i = j;
                }
            }
            m ^= (1<<i);
            for(int j = 0; j < n; ++j){
                if(m&(1<<j))
                    continue;
                d[s][j] = min(d[s][j], d[s][i] + a[i+1][j+1]);
            }
        }
        for(int i = 0; i < n; ++i)
            ans = min(ans, (d[s][i] + a[i+1][0])/cnt + 1);
    }
    return ans;
}

int main(){
    freopen("vacation.in", "r", stdin);
    freopen("vacation.out", "w", stdout);
    scanf("%d", &n);
    for(int i = 0; i <= n; ++i)
        for(int j = 0; j <= n; ++j){
            scanf("%d", &a[i][j]);
            if(a[i][j] < 0)
                a[i][j] = inf;
        }
    printf("%d\n", solve());
}
