/*GCC*/
#include <bits/stdc++.h>

using namespace std;

const long double pi = acos(-1);

vector<long double> x,y;
vector<pair<long double, int> >ln;
int n,k;

long double dist(long double dx,long double dy){
    return sqrt(dx * dx + dy * dy);
}

int main()
{
    freopen("circle.in","r",stdin);
    freopen("circle.out","w",stdout);
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    cout << fixed << setprecision(3);
    cin >> n >> k;
    x.resize(n);
    y.resize(n);
    for(int i = 0;i < n;i++)
        cin >> x[i] >> y[i];
    if(n == 1){
        cout << 0 << '\n';
        return 0;
    }
    if(n == 2){
        long double d = 999999;
        for(int i = 0;i < n;i++)
            for(int j = 0;j < i;j++)// j++
            d = min(d,dist(x[i] - x[j], y[i] - y[j]));
        cout << d / 2.0 << '\n';// space
        return 0;
    }
    long double L = 0,R = 2000;//R = 2000
    while(R - L > 0.0001){
        long double r = (L + R) / 2.0;
        int cur = 1;
        for(int i = 0;i < n && cur < k;i++){
            ln.clear();
            for(int j = 0;j < n;j++){
                if(i == j)
                    continue;
                long double d = dist(x[i] - x[j],y[i] - y[j]);
                if(2.0 * r < d)//2.0
                    continue;
                long double a = asin((y[i] - y[j]) / d);
                if(x[i] > x[j])
                    a = pi - a;
                long double b = acos(d / 2.0 / r);
                ln.push_back(make_pair(a-b,-1));
                ln.push_back(make_pair(a+b,1));//+1 -> 1
            }
            sort(ln.begin(),ln.end());
            cur = 1;
            for(int j = 0;j < ln.size() && cur < k;j++)// i -> j
                cur -= ln[j].second;
        }
        if(cur >= k)
            R = r;
        else
            L = r;
    }
    cout << R << '\n';
    return 0;
}
