#include <bits/stdc++.h>

using namespace std;

struct point {
    double x,y;
};

const double e = 1e-6;
int n,k;
point p[200];
double ans = 999999999;

double dis(point a, point b) {
    return sqrt((b.x-a.x)*(b.x-a.x) + (b.y-a.y)*(b.y-a.y));
}

point o(point a, point b, point c) {
    point res;
    double A = dis(b,c),B = dis(a,c),C = dis(a,b);
    double cos = (B*B + C*C - A*A)/(2*B*C);
    double tg = sqrt((1/(cos*cos)) - 1);
    double OM = A/(2*abs(tg));
    point m; m.x = (b.x+c.x)/2; m.y = (b.y+c.y)/2;
    if (c.y != b.y && c.x != c.y) {
        double k1,k2,b1,b2;
        k1 = (c.y-b.y)/(c.x-b.x);
        b1 = c.y - b.x*(c.y-b.y)/(c.x-b.x);
        k2 = -1/k1;
        b2 = m.y - k2*m.x;
        double tg2 = abs(k2);
        double cos2 = 1/sqrt(tg2*tg2 + 1);
        res.x = m.x - OM*cos2;
        res.y = m.y - sqrt(1 - cos2*cos2)*OM;
    } else if (c.y == b.y) {
        res.x = m.x;
        res.y = m.y + OM;
    } else {
        res.y = m.y;
        res.x = m.x + OM;
    }
    return res;
}

int main()
{
    freopen("circle.in", "r", stdin);
    freopen("circle.out", "w", stdout);
    cin >> n >> k;
    for (int i = 0; i < n; i++) cin >> p[i].x >> p[i].y;
    for (int a = 0; a < n; a++) {
        for (int b = 0; b < n; b++) {
            point A = p[a], B = p[b];
            for (int c = 0; c < n; c++) {
                point C = p[c];
                point O = o(A,B,C);
                vector <double> temp;
                int t = 0;
                for (int d = 0; d < n; d++) {
                    temp.push_back(dis(O, p[d]));
                }
                sort(temp.begin(), temp.end());
                ans = min(ans,temp[k-1]);
            }
            vector <double> temp;
            point O; O.x = (A.x+B.x)/2; O.y = (A.y+B.y)/2;
            for (int d = 0; d < n; d++) {
                temp.push_back(dis(O, p[d]));
            }
            sort(temp.begin(), temp.end());
            ans = min(ans,temp[k-1]);
        }
    }
    cout << setprecision(3) << fixed << ans << endl;
    return 0;
}
